#ifndef _DEFS_H_
#define _DEFS_H_

#define N 27

enum type { TMIN, TMAX };

typedef struct {
  enum type t;
  int n;
  int row[N*N];
  int col[N*N];
  long e;
} state;

typedef struct {
  long k;
  long kmax;
} sa;

typedef struct {
  state cur;
  state best;
  sa s;
} sub;

typedef struct {
  sub s[(27+1)* 2];
} problem;

void e(state *);
void save_best(problem *p, char *name);

void update_best(problem *, char *);
void post(problem *);

#endif /* _DEFS_H_ */
